/**************************************************************/
/**MULTI-MOVING AVERAGE, STOCHASTIC OSCILLATOR AND HEIKEN ASHI*/
/**************************************************************/
#property copyright "Copyright  2012, Brian M. E. Lillard"
#property link      "brianlillard@hotmail.com"
#include <stderror.mqh>
/**************************************************************/
/**********************-~~-{([GLOBAL^VARIABLES])}-~~-_+_+_+_+_+/
/**************************************************************/
string                     heikenashi          = "no_signal";
string                     stochastic          = "no_signal";
string                     multimovingaverage  = "no_signal";

int                        sell                = 0;
int                        buy                 = 0;
int                        tfs                 = 0;
int                        tfb                 = 0;
string                     signal              = "no_signal";
int                        MaxRetries          = 5;   
int                        MaxSlippage         = 5;  
int                        SymDigits           = 5;
double                     SymPoints           = 0.0001;

/**************************************************************/
/**********************-~~-{([INPUT^PARAMETERS])}-~~-_+_+_+_+_+/
/**************************************************************/
extern bool                HeikenAshi          = true;
extern bool                Stochastic          = true;
extern bool                StochasticLevels    = false;
extern bool                MultiMovingAverage  = true;

extern int                 Timeframe1          = 1;
extern int                 Timeframe2          = 5;
extern int                 Timeframe3          = 15;
extern int                 Timeframe4          = 30;
extern int                 Timeframe5          = 60;
extern int                 Timeframe6          = 240;

extern double              LotSize             = 0.10;  
extern int                 StopLoss            = 200;                                                                         
extern int                 TakeProfit          = 200;

extern int                 MagicNumber         = 5;
extern color               BuyArrowColor       = Blue;  
extern color               SellArrowColor      = Red;
/**************************************************************/
/**********************-~~-{([INTERNAL^VARIABLES])}-~~-_+_+_+_+/
/**************************************************************/
string                     OrderComments = "";
string                     Sym = "";
string                     Per = "";
datetime                   PrevTime = 0;
//int                        Bar = 0;
/**************************************************************/
/**********************-~~-{([DEINITIALIZATION])}-~~-_+_+_+_+_+/
/**************************************************************/
int deinit(){
   ///Comment("");
   return(0);
   }   
/**************************************************************/
/**********************-~~-{([INITIALIZATION])}-~~-_+_+_+_+_+_+/
/**************************************************************/
int init(){
   OrderComments = "TP= " + TakeProfit + ", SL= " + StopLoss + ".";
   Sym = Symbol(); 
   Per = Period();
   
   
   
   
   return(0);
   }
/**************************************************************/
/**********************-~~-{([START])}-~~-_+_+_+_+_+_+_+_+_+_+_/
/**************************************************************/
int start(){
   if(Bars < 100 || IsTradeAllowed() == false){
      Comment("EA is not running");
      return(0);
      }
      
   refreshsignals();
   comment();
   
   datetime CurrTime = iTime(Sym, Per, 1);
   //bars
   if(CurrTime == PrevTime){
      ExecuteTrade();
      return(0);
      } //end if
   PrevTime = CurrTime;
   
   //ticks
   
   
   
   
   
   
   
   return(0); //end start
   }
/**************************************************************/
/**********************-~~-{([SIGNAL^FUNCTIONS])}-~~-_+_+_+_+_+/
/**************************************************************/
void refreshsignals(){
   //MultiMovingAverage
   //sell Timeframe1
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 0, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 2, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 4, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 6, 0) == 3){
      sell++;
      } //end if
   if(sell == 4){
      tfs++; 
      sell = 0;
      }
   //sell timeframe2
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 0, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 2, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 4, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 6, 0) == 3){
      sell++;
      } //end if
   if(sell == 4){
      tfs++; 
      sell = 0;
      }
   //sell timeframe3
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 0, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 2, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 4, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 6, 0) == 3){
      sell++;
      } //end if
   if(sell == 4){
      tfs++; 
      sell = 0;
      }
   //sell timeframe4
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 0, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 2, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 4, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 6, 0) == 3){
      sell++;
      } //end if
   if(sell == 4){
      tfs++; 
      sell = 0;
      }
   //sell timeframe5
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 0, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 2, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 4, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 6, 0) == 3){
      sell++;
      } //end if
   if(sell == 4){
      tfs++; 
      sell = 0;
      }
   //sell timeframe6
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 0, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 2, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 4, 0) == 3){
      sell++;
      } //end if
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 6, 0) == 3){
      sell++;
      } //end if
   if(sell == 4){
      tfs++; 
      sell = 0;
      }
   //sell signal
   if(tfs >= 4){
      multimovingaverage = "sell";
      tfs = 0;
      } //end if
     
   //buy timeframe1
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 1, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 3, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 5, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe1, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 7, 0) == 2){
      buy++;
      } //end if
   if(buy == 4){
      tfb++; 
      buy = 0;
      }
   //buy timeframe2
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 1, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 3, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 5, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe2, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 7, 0) == 2){
      buy++;
      } //end if
   if(buy == 4){
      tfb++; 
      buy = 0;
      }
   //buy timeframe3
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 1, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 3, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 5, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe3, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 7, 0) == 2){
      buy++;
      } //end if
   if(buy == 4){
      tfb++; 
      buy = 0;
      }
   //buy timeframe4
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 1, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 3, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 5, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe4, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 7, 0) == 2){
      buy++;
      } //end if
   if(buy == 4){
      tfb++; 
      buy = 0;
      }
   //buy timeframe5
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 1, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 3, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 5, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe5, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 7, 0) == 2){
      buy++;
      } //end if
   if(buy == 4){
      tfb++; 
      buy = 0;
      }
   //buy timeframe6
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 1, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 3, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 5, 0) == 2){
      buy++;
      } //end if
   if(iCustom(NULL, Timeframe6, "Alex5757000 - Multi Moving Average v2.1", 21, 1, 6, 55, 1, 6, 89, 1, 6, 144, 1, 6, 7, 0) == 2){
      buy++;
      } //end if
   if(buy == 4){
      tfb++; 
      buy = 0;
      }
   //buy signal
   if(tfb >= 4){
      multimovingaverage = "buy";
      tfb = 0;
      } //end if
      
/**************************************************************/
   //Stocastic Oscillator
   if(StochasticLevels){
      //StocasticOscillator with levels
      //sell
      if(iCustom(NULL, 0, "Stochastic", 5, 3, 3, 1, 0) < iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0) && iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0) >= 80 || iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0) <= 20){
         stochastic = "sell";
         }
      //buy
      if(iCustom(NULL, 0, "Stochastic", 5, 3, 3, 1, 0) > iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0) && iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0) >= 80 || iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0) <= 20){
         stochastic = "buy";
         }
      }
   else{
      //StocasticOscillator without levels
      //sell
      if(iCustom(NULL, 0, "Stochastic", 5, 3, 3, 1, 0) < iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0)){
         stochastic = "sell";
         }
      //buy
      if(iCustom(NULL, 0, "Stochastic", 5, 3, 3, 1, 0) > iCustom(NULL, 0, "Stochastic", 5, 3, 3, 0, 0)){
         stochastic = "buy";
         }
      }
/**************************************************************/
   //HeikenAshi
   //sell
   if(iCustom(NULL, 0, "Heiken Ashi", 2, 0) > iCustom(NULL, 0, "Heiken Ashi", 3, 0) && iCustom(NULL, 0, "Heiken Ashi", 1, 0) < iCustom(NULL, 0, "Heiken Ashi", 0, 0)){
      heikenashi="sell";
      }
   //buy
   if(iCustom(NULL, 0, "Heiken Ashi", 2, 0) < iCustom(NULL, 0, "Heiken Ashi", 3, 0) && iCustom(NULL, 0, "Heiken Ashi", 1, 0) > iCustom(NULL, 0, "Heiken Ashi", 0, 0)){
      heikenashi="buy";
      }
   }
/**************************************************************/
/**********************-~~-{([Execute^Trade])}-~~-_+_+_+_+_+/
/**************************************************************/
void ExecuteTrade(){
   //signal to signal[SELL]
   if(signal != "sell" && heikenashi == "sell" && stochastic == "sell" && multimovingaverage == "sell"){
      signal = "sell";
      //close and reorder [ecn brokers(not stp brokers)]
      EnterSell(NULL, LotSize, OrderComments);
      } //end if
   
   //signal to signal[BUY]
   if(signal != "buy" && heikenashi == "buy" && stochastic == "buy" && multimovingaverage == "buy"){
      signal = "buy";
      //close and reorder [ecn brokers(not stp brokers)]
      EnterBuy(NULL, LotSize, OrderComments);
      } //end if
   } //end if
/**************************************************************/
/**********************-~~-{([Enter^Buy])}-~~-_+_+_+_+_+/
/**************************************************************/
int EnterBuy(string FinalSymbol, double FinalLots, string EA_Comment){
   int Ticket = -1, err = 0, TryCount = 0;
   bool OrderLoop = False; 

   while(!OrderLoop){
      while(IsTradeContextBusy()){
         Sleep(4);}

      RefreshRates();
      double SymAsk = NormalizeDouble(MarketInfo(FinalSymbol, MODE_ASK), SymDigits);
      double SymBid = NormalizeDouble(MarketInfo(FinalSymbol, MODE_BID), SymDigits);

      Ticket=OrderSend(FinalSymbol, OP_BUY, FinalLots, SymAsk, 0, 0.0, 0.0, EA_Comment, MagicNumber, 0, BuyArrowColor);

      int Err = GetLastError();
      switch(Err){
         case ERR_NO_ERROR: OrderLoop = true; 
         if(OrderSelect(Ticket, SELECT_BY_TICKET)){
            OrderModify(Ticket, OrderOpenPrice(), BuyStop(SymBid, StopLoss, SymPoints, SymDigits), BuyTake(SymAsk, TakeProfit, SymPoints, SymDigits), 0, BuyArrowColor);} 
            break;
         //---- Retry Error     
         case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
         case                ERR_REQUOTE: continue;
         //---- Fatal known Error 
         case          ERR_INVALID_STOPS: OrderLoop = true; Print("Invalid^Stops"); break; 
         case   ERR_INVALID_TRADE_VOLUME: OrderLoop = true; Print("Invalid^Lots"); break; 
         case          ERR_MARKET_CLOSED: OrderLoop = true; Print("Market^Close"); break; 
         case         ERR_TRADE_DISABLED: OrderLoop = true; Print("Trades^Disabled"); break; 
         case       ERR_NOT_ENOUGH_MONEY: OrderLoop = true; Print("Not^Enough^Money"); break; 
         case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop = true; Print("Too^Many^Orders"); break; 
         //---- Fatal Unknown Error
         case ERR_NO_RESULT:
         default: OrderLoop = true; Print("Unknown^Error=" + Err); break; 
         }
         if(TryCount > 10){
            OrderLoop = true;
            } //end if
      }//end while loop
   return(Ticket);
   }
/**************************************************************/
/**********************-~~-{([Enter^Sell])}-~~-_+_+_+_+_+_+_+_+/
/**************************************************************/
int EnterSell(string FinalSymbol, double FinalLots, string EA_Comment){
   int Ticket = -1, err = 0, TryCount = 0;

   bool OrderLoop = False; 
   while(!OrderLoop){
      while(IsTradeContextBusy()){
         Sleep(10);}
         
   RefreshRates();
   double SymAsk = NormalizeDouble(MarketInfo(FinalSymbol, MODE_ASK), SymDigits);    
   double SymBid = NormalizeDouble(MarketInfo(FinalSymbol, MODE_BID), SymDigits);

   Ticket = OrderSend(FinalSymbol, OP_SELL, FinalLots, SymBid, 0, 0.0, 0.0, EA_Comment, MagicNumber, 0, SellArrowColor); 
  
   int Err = GetLastError();
   switch(Err){
      case ERR_NO_ERROR: OrderLoop = true;
      if(OrderSelect(Ticket, SELECT_BY_TICKET)){
         OrderModify(Ticket, OrderOpenPrice(), SellStop(SymAsk, StopLoss, SymPoints, SymDigits), SellTake(SymBid, TakeProfit, SymPoints, SymDigits), 0, SellArrowColor);} 
         break;
      //---- Retry Error     
      case     ERR_TRADE_CONTEXT_BUSY: TryCount++; break;
      case                ERR_REQUOTE: continue;
      //---- Fatal known Error 
      case          ERR_INVALID_STOPS: OrderLoop=true; Print("Invalid^Stops"); break; 
      case   ERR_INVALID_TRADE_VOLUME: OrderLoop=true; Print("Invalid^Lots"); break; 
      case          ERR_MARKET_CLOSED: OrderLoop=true; Print("Market^Close"); break; 
      case         ERR_TRADE_DISABLED: OrderLoop=true; Print("Trades^Disabled"); break; 
      case       ERR_NOT_ENOUGH_MONEY: OrderLoop=true; Print("Not^Enough^Money"); break; 
      case  ERR_TRADE_TOO_MANY_ORDERS: OrderLoop=true; Print("Too^Many^Orders"); break; 
      //---- Fatal Unknown Error
      default: OrderLoop=true; Print("Unknown^Error - " + Err); break;
         }
         if(TryCount > 10){
            OrderLoop = true;
            } //end if
      }//end while loop
   return(Ticket);
   }
/**************************************************************/
/**********************-~~-{([Buy^Stoploss])}-~~-_+_+_+_+_+_+_+/
/**************************************************************/
double BuyStop(double price, double stop, double point, double SymDgts){
   if(stop == 0){
      return(0);
      }
   else{
      return(NormalizeDouble(price - stop * point, SymDgts));}
   }
/**************************************************************/
/**********************-~~-{([Buy^Takeprofit])}-~~-_+_+_+_+_+_+/
/**************************************************************/
double BuyTake(double price, double take, double point, double SymDgts){
   if(take==0){
      return(0);
      }
   else{
      return(NormalizeDouble(price + take * point, SymDgts));}
   }
/**************************************************************/
/**********************-~~-{([Sell^Stoploss])}-~~-_+_+_+_+_+_+_/
/**************************************************************/
double SellStop(double price, double stop, double point, double SymDgts){
   if(stop==0){
      return(0);
      }
   else{
      return(NormalizeDouble(price + (stop * point), SymDgts));
      }
   }
/**************************************************************/
/**********************-~~-{([Sell^Takeprofit])}-~~-_+_+_+_+_+/
/**************************************************************/
double SellTake(double price, double take, double point, double SymDgts){
   if(take == 0){
      return(0);
      }
   else{
      return(NormalizeDouble( price - (take * point), SymDgts));
      }
   }
/**************************************************************/
/**********************-~~-{([Count^Open^positions])}-~~-_+_+_+/
/**************************************************************/
/*int CountAll(string Symbole, int Magic){
   int count=0;
   for(int i = OrdersTotal() - 1; i >= 0; i--){
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()!= Magic) continue;
      if(OrderSymbol()!= Symbole) continue;
          if(OrderType() == OP_BUY){count++;}
      else if(OrderType() == OP_SELL){count++;}
      }
   return(count);
   }*/
/**************************************************************/
/**********************-~~-{([Comment])}-~~-_+_+_+_+_+_+_+_+_+_/
/**************************************************************/
void comment(){
   Comment( 
      "\n" + "=SETTINGS" +
      "\n" + "Lot_Size = " + DoubleToStr(LotSize,2) + " per pip" +
      "\n" + "Stop_Loss = " + StopLoss + " pips" +
      "\n" + "Take_Profit = " + TakeProfit + " pips" +
      "\n" + "Retries = " + MaxRetries +
      "\n" + "Slippage = " + MaxSlippage +
      "\n" + "Magic_Number = " + MagicNumber +
      "\n" + "" +
      "\n" + "=MTF_INDICATORS" +
      "\n" + "Heiken_Ashi = " + HeikenAshi + " (" + heikenashi + ")" +      
      "\n" + "Stochastic = " + Stochastic + " (" + stochastic + ")" +
      //"\n" + "Stochastic_Levels = " + StochasticLevels +      
      "\n" + "Multi_Moving_Average = " + MultiMovingAverage + " (" + multimovingaverage + ")" +
      "\n" + "" +
      "\n" + "=EA_SIGNAL" +
      "\n" + "signal = " + signal);
   }

